#ifndef __DAQ_DEVICE_MWPC_H__
#define __DAQ_DEVICE_MPWC_H__


#include <daq_device.h>
#include <iostream>

#include <arpa/inet.h>


class mwpcTriggerHandler;


class daq_device_mwpc : public  daq_device {

public:

  daq_device_mwpc (const int eventtype
		  , const int subeventid
		  , const char *ipaddr
		  , const int trigger = 0);

  ~daq_device_mwpc();


  void identify(std::ostream& os = std::cout) const;

  int max_length(const int etype) const;

  // functions to do the work

  int put_data(const int etype, int * adr, const int length);

  int init();
  int endrun();

  int rearm( const int etype);

protected:
  
  int readValue( const int adr);
  int read32bitValue(const int adrhigh, const int adrlow);
  int flush_socket() const;
  int writeValue(const int adr, const int value);

  subevtdata_ptr sevt;
  unsigned int number_of_words;

  char _ip[512];
  int _s;
  int _broken;

  int _trigger;

  unsigned short _tdcmask;

  mwpcTriggerHandler *_th;

};

#endif

