
#include <unistd.h>
#include "mwpcTriggerHandler.h"
#include <iostream>

#include <stdio.h>

using namespace std;


int mwpcTriggerHandler::wait_for_trigger( const int moreinfo)
{
  //cout << __LINE__ << "  " << __FILE__ << " entering wait_for_trigger... socket = " << _s << endl;

  if ( ! _s ) 
    {
      cout << __LINE__ << "  " << __FILE__ << " no socket returning 0... " << endl;
      return 0;
    }

  int c = 0;

  unsigned short SpillStateRegister = readValue(0xb) & 0xf;

  // cout << __LINE__ << "  " << __FILE__ << " SpillStateRegister " 
  //      << hex << SpillStateRegister << " old " << _oldValue 
  //      << dec << endl;
  
  if ( ( _oldValue != 2 && _oldValue != 0 ) &&  (SpillStateRegister == 0x2) ) // "TDC All Done"
    {
      cout << __LINE__ << "  " << __FILE__ << " returning with SpillStateRegister " << hex << SpillStateRegister << " old " << _oldValue 
	   << dec  << endl;
      _oldValue = SpillStateRegister;
      
      return 1;
    }

  _oldValue = SpillStateRegister;
  sleep(1);
  usleep(100000);
  return 0;
}


int mwpcTriggerHandler::readValue(const int adr)
{

  char str[128];
  int l = sprintf ( str, "rdb1 %x 1\n", adr);

  int i;
  int value;
  i = write (_s, str, l);
  l = read ( _s, &value, 2);

  //  cout << hex << " value = " << value << dec << endl;
  return value;
}
