#include "mwpc_plugin.h"
#include <daq_device_mwpc.h>

#include <strings.h>

int mwpc_plugin::create_device(deviceblock *db)
{

  //std::cout << __LINE__ << "  " << __FILE__ << "  " << db->argv0 << std::endl;

  if ( strcasecmp(db->argv0,"device_mwpc") == 0 ) 
    {
      // we need at least 4 or 5 params
      if ( db->npar <4 || db->npar >6 ) return 1; // indicate wrong params
      
      int eventtype  = atoi ( db->argv1); // event type
      int subid      = atoi ( db->argv2); // subevent id

      daq_device *x;
      if ( db->npar == 4 )
	{ 
	  x = new daq_device_mwpc( eventtype,
				  subid,
				  db->argv3 );
	}

      if (db->npar == 5)
	{
	  int trigger    = atoi ( db->argv4); //trigger
	  // std::cout << __LINE__ << "  " << __FILE__ << "  creating  daq_device_mwpc " << trigger << std::endl;
	  x = new daq_device_mwpc( eventtype,
				  subid,
				  db->argv3,
				  trigger );
	}

      //      x->identify();

      add_readoutdevice (x);
      return 0;  // say "we handled this request" 
    }  
  
  return -1; // say " this is not our device"
}

void mwpc_plugin::identify(std::ostream& os, const int flag) const
{

  if ( flag <=2 )
    {
      os << " - MWPC Plugin" << std::endl;
    }
  else
    {
      os << " - MWPC Plugin, provides - " << std::endl;
      os << " -     device_mwpc (evttype, subid, IP addr) - readout an MWPC crate " << std::endl;

    }
      
}

mwpc_plugin _mwpc_p;

