/**

Small test program to play with the FermiLab MWPC

*/



#include <cerrno>
#include <cstdlib>

#include <stdio.h>

#include <iomanip>
#include <iostream>
#include <string>
#include <sstream>

#include <unistd.h>
#include <netdb.h>

#include <arpa/inet.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/times.h>
#include <sys/types.h>



//#ifdef HAVE_BSTRING_H
//#include <bstring.h>
//#else
#include <strings.h>
//#endif

//#ifdef HAVE_GETOPT_H
#include <getopt.h>
//#endif

using namespace std;

int readn(int , char *, int);
int writen(int , char *, int);

void exitmsg()
{
  std::cout << "FermiLab MWPC readout test program " << std::endl;
  
  std::cout << "** usage: readtest  [parameters TBD]" << std::endl;
  exit(0);
}

int get_hexvalue(int fd, const int adr)
{

  char str[128];
  char out[128];
  int l = sprintf ( str, "rdb1 %x 1\n", adr);
  //cout << str << "| " << l << endl;

  int i;
  int value;
  i = write (fd, str, l);
  l = read ( fd, &value, 2);

  //  cout << hex << " value = " << value << dec << endl;
  return value;
}


// ---------------------------------------------------------
int i4swap(const int in)
{
  union 
  {
    int i4;
    char c[4];
  } i,o;

  i.i4 = in;
  o.c[0] = i.c[3];
  o.c[1] = i.c[2];
  o.c[2] = i.c[1];
  o.c[3] = i.c[0];
  return o.i4;
}

int i22swap(const int in)
{
  union 
  {
    int i4;
    char c[4];
  } i,o;

  i.i4 = in;
  o.c[0] = i.c[1];
  o.c[1] = i.c[0];
  o.c[2] = i.c[3];
  o.c[3] = i.c[2];
  return o.i4;
}

// ---------------------------------------------------------
short i2swap(const  short in)
{
  union 
  {
    short i2;
    char c[2];
  } i,o;

  i.i2 = in;
  o.c[0] = i.c[1];
  o.c[1] = i.c[0];

  return o.i2;
}



int main( int argc, char* argv[])
{
  int the_port;
  int status;
  char c;
  char *host_name = NULL;
  char *file_name = NULL;
  int verbose = 0;
  int i,j;

  the_port=5000;

  int nspills =1;

  if ( argc > 1 ) nspills = atoi(argv[1]);

  cout << " reading " << nspills << " spills" << endl; 

  //  while ((c = getopt(argc, argv, "viw:n:e:p:")) != EOF)

  while ((c = getopt(argc, argv, "v")) != EOF)
    {
      switch (c) 
	{

	case 'v':
	  verbose++;
	  break;

	// case 'n':
	//   sscanf (optarg,"%d", &number_of_buffers);
	//   break;

	// case 'e':
	//   sscanf (optarg,"%d", &number_of_events);
	//   break;

	// case 'p':
	//   sscanf (optarg,"%d", &the_port);
	//   break;
	// case 'w':
	//   sscanf (optarg,"%d", &waitinterval);
	//   break;
	// case 'i':
	//   identifyflag =1;
	//   break;
	}
    }

  int sockfd;
  struct sockaddr_in server_addr;
  struct hostent *p_host;
    p_host = gethostbyname("131.225.176.156");
    //p_host = gethostbyname("127.0.0.1");

  bzero( (char*) &server_addr, sizeof(server_addr) );
  server_addr.sin_family = AF_INET;
  bcopy(p_host->h_addr, &(server_addr.sin_addr.s_addr), p_host->h_length);
  server_addr.sin_port = htons(the_port);


  if ( (sockfd = socket(AF_INET, SOCK_STREAM, 0) ) < 0 )
    {
      std::cout << "error in socket" << std::endl;
      exit(1);
    }

  if ( connect(sockfd, (struct sockaddr*) &server_addr
	       , sizeof(server_addr)) < 0 ) 
    {
      std::cout << "error in connect" << std::endl;
      exit(1);
    }


  // rdb
  char rdb[] = { 'r','d','b','\n', 0};

  char wr1c[] = { 'w','r',' ','1' ,' ', '1', 'c','\n', 0};
  char p0[] = { 'p','0','\n', 0};


  unsigned int buffer[128*1024];
  unsigned short *sbuffer = ( unsigned short *) &buffer[1];
  char readback[16];

  int nwords;
  int tdccount = 0;
  int tdcmask = get_hexvalue(sockfd, 0xc);

  for ( i = 0; i < 16; i++) 
    {
      if ( (1<< i) & tdcmask ) tdccount++;
    }
  cout << __LINE__ << "  " << __FILE__ << " tdcmask is " << hex << tdcmask << dec << " TDC count = " <<tdccount << endl;

  int tries;

  for ( tries = 0; tries < nspills; tries++)
    {
      cout << "Reading spill " << tries << endl;
      //     write (sockfd, wr1c , 9);
      int oldvalue = 0;

      int go =1;
      while ( go )
      	{

      	  unsigned short SpillStateRegister = get_hexvalue(sockfd, 0xb);

	  cout << __LINE__ << "  " << __FILE__ << " SpillStateRegister " << hex << SpillStateRegister << dec << endl;
      	  SpillStateRegister &= 0xf;

      	  if (  ( oldvalue !=2 && oldvalue !=0) && SpillStateRegister == 0x2) 
      	    {
      	      go = 0;
      	    }
      	  else
      	    {
	      sleep (1);
      	      usleep (10000);
      	    }
	  oldvalue = SpillStateRegister;
      	}

      // char str[8192];
      // write ( sockfd, p0, 4);
      // nbytes  = read( sockfd, str, 8192);
      // for ( i = 0; i < nbytes; i++)
      // 	{
      // 	  cout << str[i];
      // 	}
      // cout << str << endl << endl;


      write (sockfd, rdb , 4);

      int read_so_far =  readn (sockfd, (char *) buffer, 4);
      cout << "bytes read " << read_so_far  << endl; 
      
      //      for ( i = 0; i < read_so_far/4; i++)
      //	{  
      //	  cout << setw(4) << i << "   " << hex << buffer[i] << dec << std::endl;
      //	}

      nwords = ntohl(buffer[0]);

      cout << " length is  " <<hex << "0x" << nwords   << dec << "  " << nwords << std::endl;

      if ( nwords > 4 && nwords < 4 * 128 * 1024)  
	{
	  // int n = nbytes;
	  int n = (nwords-2)*2;
	  read_so_far = readn ( sockfd, (char *) &buffer[1], n);
	}

      cout << "total bytes read in spill "  << tries << " read  " << read_so_far  << std::endl;

      // i = 0;
      // cout << setw(8) << i <<  "  " << setw(8) << hex << i2swap(sbuffer[i++]) << dec << "  Spill Counter" << endl;
      // cout << setw(8) << i <<  "  " << setw(8) << hex << i2swap(sbuffer[i++]) << dec << "  date" << endl;
      // cout << setw(8) << i <<  "  " << setw(8) << hex << i2swap(sbuffer[i++]) << dec << "  date" << endl;
      // cout << setw(8) << i <<  "  " << setw(8) << hex << i2swap(sbuffer[i++]) << dec << "  date" << endl;
      // cout << setw(8) << i <<  "  " << setw(8) << hex << i2swap(sbuffer[i++]) << dec << "  spill trigger count" << endl;
      // cout << setw(8) << i <<  "  " << setw(8) << hex << i2swap(sbuffer[i++]) << dec << "  spill status bits for TDCs" << endl;
      // cout << setw(8) << i <<  "  " << setw(8) << hex << i2swap(sbuffer[i++]) << dec << "  spill link status bits" << endl;
      // cout << endl;

      // int j,k;
      // for ( j=0; j < tdccount; j++) 
      // 	{

      // 	  cout << "Spill header for TDC " << j << endl;
      // 	  cout << setw(8) << i <<  "  " << setw(8) << hex << i2swap(sbuffer[i++]) << dec << "  spill words" << endl;
      // 	  cout << setw(8) << i <<  "  " << setw(8) << hex << i2swap(sbuffer[i++]) << dec << "  TDC Number" << endl;
      // 	  cout << setw(8) << i <<  "  " << setw(8) << hex << i2swap(sbuffer[i++]) << dec << "  spill link status bits" << endl;
      // 	  cout << setw(8) << i <<  "  " << setw(8) << hex << i2swap(sbuffer[i++]) << dec << "  spill status" << endl;
      // 	  cout << endl;
      // 	}
      
      // while ( i < read_so_far/2)
      // 	{
      // 	  cout << "TDC Event header " << endl;
      // 	  int nwords = i2swap(sbuffer[i]);
      // 	  cout << setw(8) << i <<  "  " << setw(8) << hex << i2swap(sbuffer[i++]) << dec << "  number of words" << endl;
      // 	  cout << setw(8) << i <<  "  " << setw(8) << hex << i2swap(sbuffer[i++]) << dec << "  TDC #" << endl;
      // 	  cout << setw(8) << i <<  "  " << setw(8) << hex << i2swap(sbuffer[i++]) << dec << "  Event Status" << endl;
      // 	  cout << setw(8) << i <<  "  " << setw(8) << hex << i2swap(sbuffer[i++]) << dec << "  Ordinal Trigger #" << endl;
      // 	  cout << setw(8) << i <<  "  " << setw(8) << hex << i2swap(sbuffer[i++]) << dec << "  Trigger Type" << endl;
      // 	  cout << setw(8) << i <<  "  " << setw(8) << hex << i2swap(sbuffer[i++]) << dec << "  Event time stamp" << endl;
      // 	  cout << setw(8) << i <<  "  " << setw(8) << hex << i2swap(sbuffer[i++]) << dec << "  local Event time stamp upper" << endl;
      // 	  cout << setw(8) << i <<  "  " << setw(8) << hex << i2swap(sbuffer[i++]) << dec << "  local Event time stamp lower" << endl;
      // 	  for ( k = 0; k < nwords -8; k++)
      // 	    {
      // 	      cout << setw(8) << i <<  "  " << setw(8) << hex << i2swap(sbuffer[i++]) << dec << "  TDC data" << endl;
      // 	    }
      // 	} 


      cout << endl;
      
    }
  
  
  close (sockfd);
  
  
  
  return 0;
}


int readn (int fd, char *ptr, int nbytes)
{
  int nleft, nread;
  nleft = nbytes;
  while ( nleft>0 )
    {
      nread = read (fd, ptr, nleft);
      if ( nread < 0 ) 
	return nread;
	  else if (nread == 0) 
	    break;
      nleft -= nread;
      ptr += nread;
    }
  return (nbytes-nleft);
}


int writen (int fd, char *ptr, int nbytes)
{
  int nleft, nwritten;
      nleft = nbytes;
      while ( nleft>0 )
	{
	  nwritten = write (fd, ptr, nleft);
	  if ( nwritten < 0 ) 
	    return nwritten;
	  
	  nleft -= nwritten;
	  ptr += nwritten;
	}
      return (nbytes-nleft);
}


