/**

Small test program to play with the FermiLab MWPC

*/



#include <cerrno>
#include <cstdlib>

#include <string.h>

#include <stdio.h>

#include <iomanip>
#include <iostream>
#include <string>
#include <sstream>

#include <unistd.h>
#include <netdb.h>

#include <arpa/inet.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/times.h>
#include <sys/types.h>



//#ifdef HAVE_BSTRING_H
//#include <bstring.h>
//#else
#include <strings.h>
//#endif

//#ifdef HAVE_GETOPT_H
#include <getopt.h>
//#endif

using namespace std;

int readn(int , char *, int);
int writen(int , char *, int);

void exitmsg()
{
  std::cout << "FermiLab MWPC readout test program " << std::endl;
  
  std::cout << "** usage: readtest  [parameters TBD]" << std::endl;
  exit(0);
}

// int get_hexvalue(int fd, const int adr)
// {

//   char str[128];
//   char out[128];
//   int l = sprintf ( str, "rd %x\r\n", adr);
//   //cout << str << "| " << l << endl;

//   int i;

//   i = write (fd, str, l);
//   l = read ( fd, out, 32);
//   for ( i =l-1; i >0; i--)
//     {
//       if ( out[i] == 10 || out[i] == 13) 
// 	{
// 	  out[i]=0;
// 	  l--;
// 	}
//     }
//   //cout << out << endl;

//   istringstream sarg ( out);
//   int value;
//   sarg >> hex >> value;
//   return value;
// }


int get_hexvalue(int fd, const int adr)
{

  char str[128];
  char out[128];
  int l = sprintf ( str, "rdb1 %x 1\n", adr);
  //cout << str << "| " << l << endl;

  int i;
  int value;
  i = write (fd, str, l);
  l = read ( fd, &value, 2);

  //  cout << hex << " value = " << value << dec << endl;
  return value;
}


// ---------------------------------------------------------
int i4swap(const int in)
{
  union 
  {
    int i4;
    char c[4];
  } i,o;

  i.i4 = in;
  o.c[0] = i.c[3];
  o.c[1] = i.c[2];
  o.c[2] = i.c[1];
  o.c[3] = i.c[0];
  return o.i4;
}

int i22swap(const int in)
{
  union 
  {
    int i4;
    char c[4];
  } i,o;

  i.i4 = in;
  o.c[0] = i.c[1];
  o.c[1] = i.c[0];
  o.c[2] = i.c[3];
  o.c[3] = i.c[2];
  return o.i4;
}

// ---------------------------------------------------------
short i2swap(const  short in)
{
  union 
  {
    short i2;
    char c[2];
  } i,o;

  i.i2 = in;
  o.c[0] = i.c[1];
  o.c[1] = i.c[0];

  return o.i2;
}



int main( int argc, char* argv[])
{
  int the_port;
  int status;
  char c;
  char *host_name = NULL;
  char *file_name = NULL;
  int verbose = 0;
  int i,j;

  the_port=5000;

  int nspills =1;

  if ( argc > 1 ) nspills = atoi(argv[1]);

  cout << " reading " << nspills << " spills" << endl; 

  //  while ((c = getopt(argc, argv, "viw:n:e:p:")) != EOF)

  while ((c = getopt(argc, argv, "v")) != EOF)
    {
      switch (c) 
	{

	case 'v':
	  verbose++;
	  break;

	// case 'n':
	//   sscanf (optarg,"%d", &number_of_buffers);
	//   break;

	// case 'e':
	//   sscanf (optarg,"%d", &number_of_events);
	//   break;

	// case 'p':
	//   sscanf (optarg,"%d", &the_port);
	//   break;
	// case 'w':
	//   sscanf (optarg,"%d", &waitinterval);
	//   break;
	// case 'i':
	//   identifyflag =1;
	//   break;
	}
    }


  int sockfd;
  struct sockaddr_in server_addr;
  struct hostent *p_host;
  //  p_host = gethostbyname("131.225.176.134");
  p_host = gethostbyname("127.0.0.1");
  std::cout << p_host->h_name << std::endl;

  bzero( (char*) &server_addr, sizeof(server_addr) );
  server_addr.sin_family = AF_INET;
  bcopy(p_host->h_addr, &(server_addr.sin_addr.s_addr), p_host->h_length);
  server_addr.sin_port = htons(the_port);


  if ( (sockfd = socket(AF_INET, SOCK_STREAM, 0) ) < 0 )
    {
      std::cout << "error in socket" << std::endl;
      exit(1);
    }


  if ( connect(sockfd, (struct sockaddr*) &server_addr
	       , sizeof(server_addr)) < 0 ) 
    {
      std::cout << "error in connect" << std::endl;
      exit(1);
    }


  int tdcmask = get_hexvalue(sockfd, 0xc);

  cout << " tdcmask = " << hex << tdcmask << dec << endl;


  int go =500;
  while ( go-- >0 )
    {
      
      unsigned short SpillStateRegister = get_hexvalue(sockfd, 0xb);
      
      cout << __LINE__ << "  " << __FILE__ << " SpillStateRegister " << hex << SpillStateRegister << dec << endl;
      SpillStateRegister &= 0xf;
      
      usleep (100000);

    }
  

  close (sockfd);
  
  
  
  return 0;
}


int readn (int fd, char *ptr, int nbytes)
{
  int nleft, nread;
  nleft = nbytes;
  while ( nleft>0 )
    {
      nread = read (fd, ptr, nleft);
      if ( nread < 0 ) 
	return nread;
	  else if (nread == 0) 
	    break;
      nleft -= nread;
      ptr += nread;
    }
  return (nbytes-nleft);
}


int writen (int fd, char *ptr, int nbytes)
{
  int nleft, nwritten;
      nleft = nbytes;
      while ( nleft>0 )
	{
	  nwritten = write (fd, ptr, nleft);
	  if ( nwritten < 0 ) 
	    return nwritten;
	  
	  nleft -= nwritten;
	  ptr += nwritten;
	}
      return (nbytes-nleft);
}


